/*
 * This code is part of the strategy game operational-space.
 * operational-space comes with ABSOLUTELY NO WARRANTY and is licensed under GPL-2.0.
 *    Copyright (C) 2024  VegOwOtenks, Sleppo04
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */
#ifndef SIPHASH_H
#define SIPHASH_H

#include <stdint.h>
#include <string.h>


typedef struct Bit128 {
	uint64_t first;
	uint64_t second;
} bit128_t;

typedef struct SipHashConfig {
	bit128_t key;
	int c;
	int d;
} siphashconfig_t;

struct SipHashConfig SipHash_DefaultConfig(void);

uint64_t siphash(int c, int d, const char* key, unsigned int keyLength, bit128_t* hashkey);
uint64_t siphash2(const char* key, unsigned int keyLength, struct SipHashConfig* config);

#endif /*SIPHASH_H*/
